package org.greenstone.gsdl3.gs3build.util;

import java.util.*;

public class HTMLDocTitle
{ StringBuffer title;
	private static HTMLTagVector titleStartTags;
	private static HTMLTagVector titleEndTags;
	private static HTMLTagVector titleOptEndTags;

	static
	{	titleStartTags 	= new HTMLTagVector("title,h1,h2,h3,h4,h5,h6");
		titleEndTags 		= new HTMLTagVector("title,h1,h2,h3,h4,h5,h6,body,head,table,hr,p,ul,ol,dl,dt,dd,li,tr,td,th,map");
		titleOptEndTags	= new HTMLTagVector("div,center,form");
	}

	/**
	 * Constructor: generates a title for the supplied <code>HTMLDoc</code>.
	 */
	public HTMLDocTitle(HTMLDoc doc)
	{ boolean				intitle;
		boolean				incontent;
		HTMLCText			text;
		HTMLTag				tag;
		HTMLBlock			parser;
		Enumeration		elements;
		Object				element;
		
		this.title 	= null;
		intitle			= false;
		incontent		= false;
		
		parser		=	doc.getCodedContent();
		if (parser == null)
		{	return;
		}
		elements	= parser.elements();

		while (elements.hasMoreElements())
		{ //System.out.println(read + ":" +  read.charAt(0));
			element	= elements.nextElement();
			
			if (element instanceof HTMLTag)
			{ tag = (HTMLTag) element;

				if (intitle)
				{	if (titleEndTags.matches(tag, false) ||
							(incontent && titleOptEndTags.matches(tag, false))) // if closing
					{ intitle = false;
						break;
					}
					else // else ignore it
					{
					}
				}
				else
				{	if (titleStartTags.matches(tag, true) == true)
					{ intitle			= true;
						incontent		= false;
						this.title	= new StringBuffer();
					}
				}
			}
			else
			{ text	= (HTMLCText) element;

				if (intitle == true)
				{	this.title.append(text.toString());
					if (!text.nullString())
					{ incontent	= true;
					}
				}
			}
		}
		if (this.title != null)
		{ this.title = HTMLCText.cleanString(this.title);
		}
	}

	/**
	 * @return the Title as a <code>String</code>.
	 */
	public String Title()
	{	if (this.title == null)
		{ return null;
		}
		return this.title.toString();
	}
}